/**
* @author Dirk Nordmann
* @date   14.01.2002
*/
package util;

import java.io.*; 

public class RessourceWriter
{
  private FileOutputStream _fileoutputstream;
  private BufferedOutputStream _bufferedoutputstream;

public RessourceWriter(String directory, String filename)
	throws IOException
{
	//***** make directory *****
	if(!directory.equals(""))
	{
		File file = new File(directory);
		if (!file.exists())
			file.mkdir();
       	while (!file.exists());
	}

	//***** init outputstreams *****
	 _fileoutputstream = new FileOutputStream( directory + File.separator + filename);
	_bufferedoutputstream = new BufferedOutputStream(_fileoutputstream,32768);
}

public void write(byte b)
	throws IOException
{
   	_bufferedoutputstream.write(b);
}

public void write(byte b[])
	throws IOException
{
   	_bufferedoutputstream.write(b);
}

public void writeHex2Bin(String data)
	throws IOException
{
	//* length *
	int len = data.length();
	//* convert to lowercase *
	data = data.toLowerCase();
	char[] _arr = data.toCharArray();
	for (int i=0; i < len/2; i++ )
	{
		int j = 2 * i;
		//* Write buffer *
		write(hex2bin((byte)_arr[j + 0],(byte)_arr[j + 1]));
	}
}

public void finalize()
	throws IOException
{
	//***** finalize outputstreams *****
	_bufferedoutputstream.flush();
	_bufferedoutputstream.close();
	_fileoutputstream.close();
}



public static char[] _hexchar2dec = new char[255];
		
static
{
    //* hexadecimal character to decimal value conversion table *
    for (int i=0; i < _hexchar2dec.length; i++)
    {
   		switch ((char)i)
   		{
  			case '1': _hexchar2dec[i] = 1;
				break;
  			case '2': _hexchar2dec[i] = 2;
				break;
  			case '3': _hexchar2dec[i] = 3;
				break;
  			case '4': _hexchar2dec[i] = 4;
				break;
  			case '5': _hexchar2dec[i] = 5;
				break;
  			case '6': _hexchar2dec[i] = 6;
				break;
  			case '7': _hexchar2dec[i] = 7;
				break;
  			case '8': _hexchar2dec[i] = 8;
	   			break;
  			case '9': _hexchar2dec[i] = 9;
	   			break;
  			case 'a':
  			case 'A': _hexchar2dec[i] = 10;
	   			break;
 			case 'b':
   			case 'B': _hexchar2dec[i] = 11;
				break;
   			case 'c':
   			case 'C': _hexchar2dec[i] = 12;
				break;
   			case 'd':
   			case 'D': _hexchar2dec[i] = 13;
				break;
   			case 'e':
   			case 'E': _hexchar2dec[i] = 14;
				break;
   			case 'f':
   			case 'F': _hexchar2dec[i] = 15;
				break;
   			default: _hexchar2dec[i] = 0;
				break;
	    }
	}
}

public static byte hex2bin(byte hi, byte lo)
{
	return (byte)(_hexchar2dec[hi] * 16 +  _hexchar2dec[lo]);
}
    	
public static byte[] hex2bin(byte[] buff, int offs, String data)
{
	//* length *
	int len = data.length();
	//* convert to lowercase *
	data = data.toLowerCase();
	char[] _arr = data.toCharArray();
	for (int i=0; i < len/2; i++ )
	{
		int j = 2 * i;
		//* Write buffer *
		buff[offs + i] = hex2bin((byte)_arr[j + 0],(byte)_arr[j + 1]);
	}
	return buff;
}
    	
public static void dump(byte[] data, String directory, String filename)
{
	dump(data, directory, filename, 0, data.length);
}
    
    public static void dump(byte[] data, String directory, String filename, int data_start, int data_end)
    {
    	try
    	{
			//***** make directory *****
			if(!directory.equals(""))
			{
				File file = new File(directory);
				if (!file.exists())
					file.mkdir();
            	while (!file.exists());
    		}

			//***** dump file *****
			FileOutputStream fileoutputstream = new FileOutputStream( directory + File.separator + filename);
            BufferedOutputStream bufferedoutputstream = new BufferedOutputStream(fileoutputstream,32768);
            for (int i = data_start; i < data_end; i++)
            	bufferedoutputstream.write(data[i]);
            bufferedoutputstream.flush();
            bufferedoutputstream.close();
            fileoutputstream.close();
        }
        catch(IOException ex)
        {
            System.out.println("[RessourceWriter.dump]: ***** IO-AUSNAHMEFEHLER: " + ex.toString());
        }
    }
    
}